using Debug = Lucene.Net.Diagnostics.Debug; // LUCENENET NOTE: We cannot use System.Diagnostics.Debug because those calls will be optimized out of the release!

namespace Lucene.Net.Util
{
    /*
     * Licensed to the Apache Software Foundation (ASF) under one or more
     * contributor license agreements.  See the NOTICE file distributed with
     * this work for additional information regarding copyright ownership.
     * The ASF licenses this file to You under the Apache License, Version 2.0
     * (the "License"); you may not use this file except in compliance with
     * the License.  You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */

    /// <summary>
    /// Prints nothing. Just to make sure tests pass w/ and without enabled <see cref="InfoStream"/>
    /// without actually making noise.
    /// <para/>
    /// @lucene.experimental
    /// </summary>
    public class NullInfoStream : InfoStream
    {
        public override void Message(string component, string message)
        {
            Debug.Assert(component != null);
            Debug.Assert(message != null);
        }

        public override bool IsEnabled(string component)
        {
            Debug.Assert(component != null);
            return true; // to actually enable logging, we just ignore on message()
        }

        protected override void Dispose(bool disposing)
        {
        }
    }
}